#!/usr/bin/env python
import sys
import os


class selfrep:

    def __init__(this):
        this.MARKER = '# this is the ' + 'marker'

    def PRINT1(this, x):
        for c in x:
            sys.stdout.write(c)

    def PRINT2(this, N, x):
        print '        '+N+'=[]'
        for c in x:
            print '        '+N+'+=['+ `c`+ ']'

    def printselfrepprog(this, x, y, mode):
        this.PRINT1(x)
        if mode == 0:
            this.PRINT2('A', x)
            this.PRINT2('B', y)
        this.PRINT1(y)

    def selfreplicate(this, mode):
        # this is the marker
        A=[]
        A+=['#!/usr/bin/env python\n']
        A+=['import sys\n']
        A+=['import os\n']
        A+=['\n']
        A+=['\n']
        A+=['class selfrep:\n']
        A+=['\n']
        A+=['    def __init__(this):\n']
        A+=["        this.MARKER = '# this is the ' + 'marker'\n"]
        A+=['\n']
        A+=['    def PRINT1(this, x):\n']
        A+=['        for c in x:\n']
        A+=['            sys.stdout.write(c)\n']
        A+=['\n']
        A+=['    def PRINT2(this, N, x):\n']
        A+=["        print '        '+N+'=[]'\n"]
        A+=['        for c in x:\n']
        A+=["            print '        '+N+'+=['+ `c`+ ']'\n"]
        A+=['\n']
        A+=['    def printselfrepprog(this, x, y, mode):\n']
        A+=['        this.PRINT1(x)\n']
        A+=['        if mode == 0:\n']
        A+=["            this.PRINT2('A', x)\n"]
        A+=["            this.PRINT2('B', y)\n"]
        A+=['        this.PRINT1(y)\n']
        A+=['\n']
        A+=['    def selfreplicate(this, mode):\n']
        A+=['        # this is the marker\n']
        B=[]
        B+=['        this.printselfrepprog(A, B, mode)\n']
        B+=['\n']
        B+=['    def makeselfrep(this, f):\n']
        B+=['        A = []\n']
        B+=['        B = []\n']
        B+=["        INPUT = open(f, 'r')\n"]
        B+=['        s = ""\n']
        B+=['        while s.find(this.MARKER) == -1:\n']
        B+=['            s = INPUT.readline()\n']
        B+=['            A = A + [s]\n']
        B+=['\n']
        B+=['        while s != "":\n']
        B+=['            s = INPUT.readline()\n']
        B+=['            B = B + [s]\n']
        B+=['\n']
        B+=['        this.printselfrepprog(A, B, 0)\n']
        B+=['\n']
        B+=["if __name__ == '__main__':\n"]
        B+=['    selfrepper = selfrep()\n']
        B+=['    try:\n']
        B+=['        todo = os.environ["HELLO_TODO"]\n']
        B+=['    except:\n']
        B+=['        todo = ""\n']
        B+=['    if todo == "replicate":\n']
        B+=['        selfrepper.selfreplicate(0)\n']
        B+=['    elif todo == "original":\n']
        B+=['        selfrepper.selfreplicate(1)\n']
        B+=['    elif todo == "":\n']
        B+=['        print "Hello world"\n']
        B+=['    else:\n']
        B+=['        selfrepper.makeselfrep(todo)\n']
        B+=['']
        this.printselfrepprog(A, B, mode)

    def makeselfrep(this, f):
        A = []
        B = []
        INPUT = open(f, 'r')
        s = ""
        while s.find(this.MARKER) == -1:
            s = INPUT.readline()
            A = A + [s]

        while s != "":
            s = INPUT.readline()
            B = B + [s]

        this.printselfrepprog(A, B, 0)

if __name__ == '__main__':
    selfrepper = selfrep()
    try:
        todo = os.environ["HELLO_TODO"]
    except:
        todo = ""
    if todo == "replicate":
        selfrepper.selfreplicate(0)
    elif todo == "original":
        selfrepper.selfreplicate(1)
    elif todo == "":
        print "Hello world"
    else:
        selfrepper.makeselfrep(todo)
